<?php

  session_start();
  include('../../../php/conn_2.php');
  if(!isset($_SESSION["id"])){
    header('Location: index.php');
  }

  mysqli_query($enlace, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");
  mysqli_query($enlacehost, "SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'");

  // Asigna mes por defecto cuando venga vacío
  $filtro_mes = '';

  // Obtiene todos los parámetros por defecto
  if($_GET["mes"] == 'null'){
  	// Nombre de tabla de resultados
    $query = "SELECT tabla_encuesta FROM tb_encuesta WHERE cod_cliente = ".$_GET["cod_cliente"]." ORDER BY orden_encuesta LIMIT 1";

    if ($res = mysqli_query($enlace, $query)) {
      if (mysqli_num_rows($res) > 0) {
        while($row = mysqli_fetch_assoc($res)) {
          $nom_tabla = $row["tabla_encuesta"];
        }
      }
    }

    // Encuesta
    $query = "SELECT cod_encuesta FROM tb_encuesta WHERE cod_cliente = ".$_GET["cod_cliente"]." ORDER BY orden_encuesta LIMIT 1";

    if ($res = mysqli_query($enlace, $query)){
      while($row = mysqli_fetch_array($res)){
        $filtro_encuesta = $row["cod_encuesta"];
      };
    }

	// Último año con datos
    $query = "SELECT YEAR(submitdate) AS Anho FROM ".$nom_tabla." WHERE submitdate IS NOT NULL GROUP BY YEAR(submitdate) ORDER BY 1 DESC LIMIT 1";

    if ($res = mysqli_query($enlace, $query)){
      while($row = mysqli_fetch_array($res)){
        $filtro_anho = $row["Anho"];
      };
    }

    // Último mes con datos
    $query = "SELECT cod_mes FROM ".$nom_tabla." WHERE submitdate IS NOT NULL AND cod_anho = ".$filtro_anho." GROUP BY cod_mes ORDER BY 1 DESC LIMIT 1";

    if ($res = mysqli_query($enlace, $query)){
      while($row = mysqli_fetch_array($res)){
        $filtro_mes = $row["cod_mes"];
      };
    }

	$filtro_filtros = '';
  }
  else{
  	$nom_tabla = $_GET["tabla_resultados"];

  	$filtro_encuesta = $_GET["cod_encuesta"];
  	$filtro_anho = $_GET["anho"];
  	$filtro_mes = $_GET["mes"];
  	$filtro_filtros = $_GET["filtros"];
  }

  // Arma los filtros
  if(isset($filtro_filtros)){
    if(strlen($filtro_filtros) > 0){
      $filtros = " AND ".$filtro_filtros;

      $filtros = str_replace("$", " ", $filtros);
    }
  }

?>

<!DOCTYPE html>
<html lang="es">
  <head>

  </head>

  <body>
    <div class="">
      <div class="row">
        <div class="col-md-12 col-sm-12 col-xs-12">

          <?php
            // Obteniendo los proyectos y fechas
              $query_proy = "SELECT Id, 454723X10X85 AS cod_proyecto, proyecto, submitdate FROM ".$nom_tabla." WHERE cod_anho = ".$filtro_anho." AND cod_mes = ".$filtro_mes." ".$filtros." ORDER BY proyecto, Id DESC";

              if ($res_proy = mysqli_query($enlace, $query_proy)) {
                if (mysqli_num_rows($res_proy) > 0) {
                  while($row_proy = mysqli_fetch_assoc($res_proy)) {
                    $Tolerancia_CERO = 0;

                    echo '<div class="row">';
                      echo '<div class="col-md-12 col-sm-12 col-xs-12">';
                        echo '<div class="x_panel">';
                          echo '<div class="x_title">';
                            echo '<h2><b>'.$row_proy["proyecto"].'</b></h2>';
                            echo '<div class="clearfix"/>';
                          echo '</div>';
                          echo '<div class="x_content">';
                            echo '<p>';
                              echo 'Fecha: <b>'.$row_proy["submitdate"].'</b>';
                            echo '</p>';
                            // echo '<p>';
                            //   echo 'Resultado de la Auditoría:';
                            // echo '</p>';
                            // echo '<p>';
                            //   echo 'Se cumplió con el 97% de los puntos evaluados:';
                            // echo '</p>';

                            // Armando la tabla de resúmenes (CABECERA)
                            echo '<table id="'.$row_proy["cod_proyecto"].'_'.$row_proy["Id"].'" class="table table-striped jambo_table bulk_action">';
                            echo '  <thead>';
                            echo '    <tr>';
                            echo '      <th><center>Unidad Auditable<center></th>';
                            echo '      <th><center>Puntos Posibles<center></th>';
                            echo '      <th><center>Puntos Observados<center></th>';
                            echo '      <th><center>Observaciones<center></th>';
                            echo '    </tr>';
                            echo '  </thead>';

                            // (DETALLE)
                            echo '  <tbody>';
                              // Obteniendo los detalles
                                $total_pp = 0;
                                $total_po = 0;

                                $query_g = "SELECT gid, group_name FROM lime_groups WHERE sid = ".$filtro_encuesta." AND gid NOT IN (10, 16) ORDER BY group_order";

                                if ($res_g = mysqli_query($enlacehost, $query_g)) {
                                  if (mysqli_num_rows($res_g) > 0) {
                                    while($row_g = mysqli_fetch_assoc($res_g)) {
                                      echo '  <tr>';
                                      echo '    <td>'.$row_g["group_name"].'</td>';

                                      // Obteniendo puntos posibles (Conjunto de preguntas por cada grupo de datos)
                                        $query_pp_sum = '';
                                        $query_pp_sc = "SHOW COLUMNS FROM ".$nom_tabla." WHERE Field LIKE '".$filtro_encuesta."X".$row_g["gid"]."X%'";

                                        if ($res_pp_sc = mysqli_query($enlace, $query_pp_sc)) {
                                          if (mysqli_num_rows($res_pp_sc) > 0) {
                                            while($row_pp_sc = mysqli_fetch_assoc($res_pp_sc)) {
                                              $query_pp_sum .= 'CASE WHEN '.$row_pp_sc["Field"].' <> 3 THEN 1 ELSE 0 END +';
                                            }

                                            $query_pp_sum = substr($query_pp_sum, 0, -2);
                                          }
                                        }

                                        // Armando el query final
                                          $query_pp = "SELECT ".$query_pp_sum." AS PUNTOS_POSIBLES FROM ".$nom_tabla." WHERE cod_anho = ".$filtro_anho." AND cod_mes = ".$filtro_mes." ".$filtros." AND 454723X10X85 = ".$row_proy["cod_proyecto"]. " AND Id = ".$row_proy["Id"];

                                          if ($res_pp = mysqli_query($enlace, $query_pp)) {
                                            if (mysqli_num_rows($res_pp) > 0) {
                                              while($row_pp = mysqli_fetch_assoc($res_pp)) {
                                                $g_pp = $row_pp["PUNTOS_POSIBLES"];

                                                echo '    <td><center>'.$g_pp.'</center></td>';
                                              }
                                            }
                                          }

                                      // Obteniendo puntos observados (Conjunto de preguntas por cada grupo de datos)
                                        $query_po_sum = '';
                                        $query_po_sc = "SHOW COLUMNS FROM ".$nom_tabla." WHERE Field LIKE '".$filtro_encuesta."X".$row_g["gid"]."X%'";

                                        if ($res_po_sc = mysqli_query($enlace, $query_po_sc)) {
                                          if (mysqli_num_rows($res_po_sc) > 0) {
                                            while($row_po_sc = mysqli_fetch_assoc($res_po_sc)) {
                                              $query_po_sum .= 'CASE WHEN '.$row_po_sc["Field"].' = 2 THEN 1 ELSE 0 END +';

                                              // Verifica si es "Tolerancia CERO" para asignarlo como "NO CUMPLE"
                                                $query_T0_check = "SELECT ".$row_po_sc["Field"]." AS field_valor FROM ".$nom_tabla." WHERE cod_anho = ".$filtro_anho." AND cod_mes = ".$filtro_mes." ".$filtros." AND 454723X10X85 = ".$row_proy["cod_proyecto"]. " AND Id = ".$row_proy["Id"];

                                                if ($res_T0_check = mysqli_query($enlace, $query_T0_check)) {
                                                  if (mysqli_num_rows($res_T0_check) > 0) {
                                                    while($row_T0_check = mysqli_fetch_assoc($res_T0_check)) {
                                                      if ($row_T0_check["field_valor"] == 2){
                                                        $Tolerancia_CERO = 1;
                                                      }
                                                    }
                                                  }
                                                }
                                            }

                                            $query_po_sum = substr($query_po_sum, 0, -2);
                                          }
                                        }

                                        // Armando el query final
                                          $query_po = "SELECT ".$query_po_sum." AS PUNTOS_OBSERVADOS FROM ".$nom_tabla." WHERE cod_anho = ".$filtro_anho." AND cod_mes = ".$filtro_mes." ".$filtros." AND 454723X10X85 = ".$row_proy["cod_proyecto"]. " AND Id = ".$row_proy["Id"];

                                          if ($res_po = mysqli_query($enlace, $query_po)) {
                                            if (mysqli_num_rows($res_po) > 0) {
                                              while($row_po = mysqli_fetch_assoc($res_po)) {
                                                $g_po = $row_po["PUNTOS_OBSERVADOS"];

                                                if ($g_po > 0){
                                                  echo '    <td><center><b><u>';
                                                  echo '      <a class="success" href="javascript: f_VerObservados('."'(".$row_proy["proyecto"].") - ".$row_g["group_name"]."'".', '."'".$row_proy["cod_proyecto"]."'".', '."'".$row_g["gid"]."'".', '."'".$row_proy["Id"]."'".')"><font color=#f21d1d>'.$g_po.'</font></a>';
                                                  echo '    </u></b></center></td>';
                                                }
                                                else{
                                                  echo '    <td><center>'.$g_po.'</center></td>';
                                                }
                                              }
                                            }
                                          }

                                      // Obteniendo cumplimiento
                                        $cum = round(($g_po / $g_pp) * 100);

                                        echo '    <td><center>'.$cum.'%</center></td>';

                                      echo '  </tr>';

                                      $total_pp += $g_pp;
                                      $total_po += $g_po;
                                    }

                                    echo '  <tr>';
                                    echo '    <td class="text-right" style="background-color:rgb(92,184,92)"><b><font color=#ffffff>TOTAL</b></td>';
                                    echo '    <td class="text-right" style="background-color:rgb(92,184,92)"><center><b><font color=#ffffff>'.$total_pp.'</b></center></td>';

                                    echo '    <td class="text-right" style="background-color:rgb(92,184,92)"><center><b><font color=#ffffff>'.$total_po.'</b></center></td>';

                                    echo '    <td style="background-color:rgb(92,184,92)"></td>';
                                    echo '  </tr>';

                                    $cumplimiento = round((1 - ($total_po / $total_pp)) * 100);
                                  }

                                  mysqli_free_result($res_g);
                                }
                            echo '  </tbody>';
                            echo '</table>';

                            echo '<p>';
                              if ($cumplimiento < 85){
                                echo 'Resultado de la Auditoría: <b><font color=#f21d1d size="3">NO CUMPLE</font></b>';
                              }
                              else{
                                // Verifica si es Tolerancia CERO
                                  if ($Tolerancia_CERO == 1){
                                    echo 'Resultado de la Auditoría: <b><font color=#f21d1d size="3">NO CUMPLE</font></b>';
                                  }
                                  else{
                                    echo 'Resultado de la Auditoría: <b><font color=#5cb85c size="3">CUMPLE</font></b>';
                                  }
                              }
                            echo '</p>';
                            echo '<p>';
                              echo 'Se cumplió con el: <b><font color=#343333 size="4"> '.$cumplimiento.'%</font></b>  de los puntos evaluados:';
                            echo '</p>';

                          echo '</div>';
                        echo '</div>';
                      echo '</div>';
                    echo '</div>';
                  }
                }
                mysqli_free_result($res_proy);
              }
          ?>
        </div>
      </div>
    </div>

    <script type="text/javascript">
      // Ver Detalles
      function f_VerObservados(titulo_ventana, cod_proyecto, cod_grupo, id_resultados){
        var modal = $("#divmodal_VerObservados");

        var nom_tabla = '<?php echo $nom_tabla; ?>';
        var filtro_encuesta = '<?php echo $filtro_encuesta; ?>';
        var filtro_anho = '<?php echo $filtro_anho; ?>';
        var filtro_mes = '<?php echo $filtro_mes; ?>';
        var filtros = '<?php echo $filtros; ?>';


        // Colocando el título a la pantalla
          $("#titulomodal").html('<b>'+titulo_ventana+'</b>"');

        //Cargando la tabla
          var htmlContenido = "<thead>";
          htmlContenido += "  <tr>";
          htmlContenido += "    <th><center>N°</center></th>";
          htmlContenido += "    <th><center>Puntos Observado</center></th>";
          htmlContenido += "    <th><center>Tolerancia CERO</center></th>";
          htmlContenido += "  </tr>";
          htmlContenido += "</thead>";
          htmlContenido += "<tbody>";

        var i = 1;

        $("#tabla_detalles").html(htmlContenido);

        $.post( "ajax/encuesta.php", { accion: "cargaPuntosObservadosAuditorias", cod_proyecto: cod_proyecto, cod_grupo: cod_grupo, id_resultados: id_resultados, nom_tabla: nom_tabla, encuesta: filtro_encuesta, anho: filtro_anho, mes: filtro_mes, filtros: filtros }, 
          function( data ) {
            if(data.estado == 1){
              var _num = 1;

              $.each( data.registros, function( key, val ) {
                htmlContenido += '<tr Style="font-size: 12px">';

                htmlContenido += '  <td style="width:1%;">'+_num+'</td>';
                htmlContenido += '  <td style="width:70%;">'+val.question+'</td>';

                if(val.T0_des.length > 0){
                  htmlContenido += '  <td style="width:29%;"><font color=#f21d1d>'+val.T0_des+'</font></td>';
                }
                else{
                  htmlContenido += '  <td style="width:39%;">'+val.T0_des+'</td>';
                }

                htmlContenido += "</tr>";

                _num += 1
              });
            }

            $("#tabla_detalles").html(htmlContenido);
          }, "json");

        htmlContenido += "</tbody>";

        $("#tabla_detalles").html(htmlContenido);

        modal.modal({backdrop: 'static', keyboard: false});
      };

      // Cerrar ventanas modales
      function f_cerrarModal(pantalla_modal){
        if (pantalla_modal == 1){
          $('#divmodal_VerObservados').modal('hide');;
        }
      };

    </script>
  </body>
</html>

<?php
  cerrarSesion($enlace);
  cerrarSesion($enlacehost);
?>
